#!/usr/bin/env python
from copy import *
from inspect import *
from os.path import *
from sys import *
from isstring import *
from public import *

class TypeError(TypeError): pass
class Exception(Exception): pass

@public
def ispublic(object,module=None):
    if not object: return False
    if not module:
        module = getmodule(object)
    if not module:
        err = "%s module is None" % object
        raise TypeError(err)
    __all__ = module.__dict__.get("__all__",None)
    name = None
    if hasattr(object,"__name__"):
        name = object.__name__
    else:
        if isstring(object):
            name = object
        else:
            for _name,member in getmodule(module):
                if member==object:
                    name = _name
                    continue
            if not name:
                err = "unknown name for %s" % object
                raise TypeError(err)
    if __all__:
        return name in __all__
    return name.find("_")!=0

if __name__=="__main__":
    print(__all__)
    print(ispublic(ispublic)) # True

